
blGradReplace = {};

function drawGradWindow()

	NUMGRADIENTS = 2;

	wParentGrad = Turbine.UI.Lotro.Window()
	wParentGrad:SetSize(iParentWidth,130);
	wParentGrad:SetText("Create Gradient");

	combinedHeight = wParentWin:GetHeight() + wParentGrad:GetHeight();

	if (wParentWin:GetTop()+combinedHeight)>SCREENHEIGHT then

		wParentWin:SetTop(SCREENHEIGHT-combinedHeight);

	end

	wParentGrad:SetPosition(wParentWin:GetLeft(),(wParentWin:GetTop()+wParentWin:GetHeight()));
	wParentGrad:SetVisible(true);

	wParentGrad.Closing = function (sender, args)

		btnGradient:SetEnabled(true);
		btnTarget:SetEnabled(true);

	end

	wParentWin.Closing = function(sender, args)

		if wParentGrad:IsVisible(true) then wParentGrad:Close() end;

	end


	wGradLine = Turbine.UI.Window();
	wGradLine:SetParent(wParentGrad);
	wGradLine:SetSize((iParentWidth-100),3);
	wGradLine:SetPosition((iParentWidth/2)-(wGradLine:GetWidth()/2),80);
	wGradLine:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2));
	wGradLine:SetVisible(true);

	bPreview = Turbine.UI.Lotro.Button();
	bPreview:SetParent(wParentGrad);
	bPreview:SetSize(100,30);
	bPreview:SetPosition((iParentWidth/2)-(bPreview:GetWidth()/2),(wGradLine:GetTop()+10));
	bPreview:SetText("Generate");
	bPreview:SetVisible(true);

	bPreview.MouseClick = function(sender,args)

		--Calculate gradient and display in chat box
		CalcGradient(txtInput:GetText());

	end


	wGradBack = Turbine.UI.Window();
	wGradBack:SetParent(wParentGrad);
	wGradBack:SetSize((iParentWidth-76),24);
	wGradBack:SetPosition((iParentWidth/2)-(wGradBack:GetWidth()/2),50);
	wGradBack:SetBackColor(Turbine.UI.Color(0,0,0));
	wGradBack:SetVisible(true);

	wGradBack.MouseClick = function(sender, args)

		if (args.Button == Turbine.UI.MouseButton.Right) then

			local blReplaceActive = false;

			-- Right mouse button pressed over the window, so add a new colour box.

			for i=1, NUMGRADIENTS, 1 do

				if blGradReplace[i] == true then

					blReplaceActive = true;

				end

			end

			if blReplaceActive == false then

				gradAdd(args.X);

			end

		end

	end


	wGradBox = {};
	wGradBoxCol = {};

	-- default color boxes, one at each end
	wGradBox[1] = Turbine.UI.Window();
	wGradBox[1]:SetParent(wGradBack);
	wGradBox[1]:SetSize(24,24);
	wGradBox[1]:SetPosition(0,0);
	wGradBox[1]:SetBackColor(Turbine.UI.Color(1,1,1));
	wGradBox[1]:SetVisible(true);

	wGradBoxCol[1] = Turbine.UI.Window();
	wGradBoxCol[1]:SetParent(wGradBox[1]);
	wGradBoxCol[1]:SetSize(22,22);
	wGradBoxCol[1]:SetPosition(1,1);
	wGradBoxCol[1]:SetBackColor(Turbine.UI.Color(1,1,1));
	wGradBoxCol[1]:SetVisible(true);

	wGradBoxCol[1].MouseClick = function (sender,args)

		if (args.Button == Turbine.UI.MouseButton.Right) then

			displayGradMenu(sender,1);

		else

			colorString = sender:GetBackColor();
			SetColor(colorString.R,colorString.G,colorString.B);

		end

	end

	wGradBox[2] = Turbine.UI.Window();
	wGradBox[2]:SetParent(wGradBack);
	wGradBox[2]:SetSize(24,24);
	wGradBox[2]:SetPosition(wGradBack:GetWidth()-24,0);
	wGradBox[2]:SetBackColor(Turbine.UI.Color(1,1,1));
	wGradBox[2]:SetVisible(true);

	wGradBoxCol[2] = Turbine.UI.Window();
	wGradBoxCol[2]:SetParent(wGradBox[2]);
	wGradBoxCol[2]:SetSize(22,22);
	wGradBoxCol[2]:SetPosition(1,1);
	wGradBoxCol[2]:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5));
	wGradBoxCol[2]:SetVisible(true);

	wGradBoxCol[2].MouseClick = function (sender,args)

		if (args.Button == Turbine.UI.MouseButton.Right) then

			displayGradMenu(sender,2);

		else

			colorString = sender:GetBackColor();
			SetColor(colorString.R,colorString.G,colorString.B);

		end

	end

end

function CalcGradient(text)

	text = string.gsub(text, ";target", "");

	tempString = text;
	tempSource = text;
	local sLength = string.len(tempString);

	--NUMGRADIENTS = 2;

	if sLength > 0 then

		-- 1 = start, so position 0% on scale
		-- 2 = middle, GetLeft()+11 / GetWidth()
		-- 3 = end, so position 100% on scale

		local gradBox = {};

		for i=1, NUMGRADIENTS, 1 do

			local tempBackColor = wGradBoxCol[i]:GetBackColor();

			gradBox[i] =
			{
			["red"] = math.floor(255*tempBackColor.R);
			["green"] = math.floor(255*tempBackColor.G);
			["blue"] = math.floor(255*tempBackColor.B);
			["position"] = math.floor(100*((wGradBox[i]:GetLeft()+11)/wGradBack:GetWidth()));
			};

		end

		gradBox[1].position = 0; -- reset first box to position 0
		gradBox[NUMGRADIENTS].position = 100; -- reset last box to position 100


		local bufferString = "";

		for i=1,sLength,1 do

			local curCharPos = math.ceil(100*(i/sLength));

			-- Find which two color blocks the current character is between
			local tempBlockPosition = 0;
			local index = 0;

			while tempBlockPosition < curCharPos do

				index = index + 1;
				tempBlockPosition = gradBox[index].position;

			end

			-- block end colour from index, start colour from index-1
			local sBlockLength = math.ceil(sLength*((gradBox[index].position - gradBox[index-1].position)/100));

			local startRed = gradBox[index-1].red;
			local endRed = gradBox[index].red;
			local varRed = endRed-startRed;
			local redChar = varRed/sBlockLength;

			local startGreen = gradBox[index-1].green;
			local endGreen = gradBox[index].green;
			local varGreen = endGreen-startGreen;
			local greenChar = varGreen/sBlockLength;

			local startBlue = gradBox[index-1].blue;
			local endBlue = gradBox[index].blue;
			local varBlue = endBlue-startBlue;
			local blueChar = varBlue/sBlockLength;

			local relPosition = i - math.ceil(sLength*(gradBox[index-1].position/100));


			-- Loop through each individual character applying it's own hex code.
			local newRed = math.floor(startRed + (redChar * relPosition));
			local newGreen = math.floor(startGreen + (greenChar * relPosition));
			local newBlue = math.floor(startBlue + (blueChar * relPosition));

			if newRed > 255 then newRed = 255 end;
			if newRed < 0 then newRed = 0 end;
			if newGreen > 255 then newGreen = 255 end;
			if newGreen < 0 then newGreen = 0 end;
			if newBlue > 255 then newBlue = 255 end;
			if newBlue < 0 then newBlue = 0 end;


			local hexCode = TO_HEX(newRed) .. TO_HEX(newGreen) .. TO_HEX(newBlue);

			_MARKUP[i].COLOR = hexCode;

			bufferString = bufferString .. "<rgb=#" .. hexCode .. ">" .. string.sub(tempString,i,i) .. "</rgb>";

		end

		OutputSuper = bufferString;


		local gradString = "";

		if tempChannel == "/tell" then

			local playerTell = txtTell:GetText();

			if playerTell ~= "" then

				gradString = tempChannel .. " " .. playerTell .. " " .. bufferString;

			end

		else

			gradString = tempChannel .. " " .. bufferString;

		end

		tempString = gradString;
		qsTemp:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, gradString));

		--Turbine.Shell.WriteLine("<rgb=#FFFFFF>Gradient Preview, this is how it will appear when you 'Send' to your selected channel:</rgb>");
		--Turbine.Shell.WriteLine(bufferString);


		txtOutput:SetText(bufferString);
		--txtInput:SetText(bufferString);

	end

end

function displayGradMenu(sender,index)

	createGradMenu(sender,index);

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();
	local menuHeight = winGradMenuBody:GetHeight();
	local menuWidth = winGradMenuBody:GetWidth();

	if (initX + menuWidth) > screenWidth then
		-- Menu will appear off-screen to the left, so load it to the right
		-- of the mouse location.#
		winGradMenuBody:SetLeft(initX - menuWidth);
	else
		winGradMenuBody:SetLeft(initX);
	end

	if (initY + menuHeight) > (screenHeight - 75) then
		-- Menu will appear off-screen to the bottom, so load it to touch
		-- the bottom of the screen.
		winGradMenuBody:SetTop(screenHeight - menuHeight - 75);
	else
		winGradMenuBody:SetTop(initY);
	end

	gscrollBar:SetValue(0);
	winGradMenuHolder:SetTop(0);

	winGradMenuParent:SetVisible(true);

end


function createGradMenu(BlockSender,index)

	-- Data storeage

	local MenuBackcolor = Turbine.UI.Color(0.0, 0.0, 0.0);

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();

	--local menuMaxHeight = (screenHeight / 2);
	local menuMaxHeight = 200;
	local menuCurHeight = 0;
	local menuCurTop = 3;

	local i = 1;
	local mCounter = 1;
	local lineHeight = 25; -- Height of each line in the menu.
	local linebuffer = 3;
	local menuWidth = 145;

	-------------------------------------------------------------------------
	-- Windows

	winGradMenuParent = Turbine.UI.Window();
	winGradMenuParent:SetBackColor(MenuBackcolor);
	winGradMenuParent:SetMouseVisible(true);
	winGradMenuParent:SetOpacity(0);
	winGradMenuParent:SetPosition(0,0);
	winGradMenuParent:SetSize(screenWidth,screenHeight);
	winGradMenuParent:SetVisible(false);
	winGradMenuParent:SetZOrder(198);

	winGradMenuBody = Turbine.UI.Window();
	winGradMenuBody:SetParent(winGradMenuParent);
	winGradMenuBody:SetBackColor(MenuBackcolor);
	winGradMenuBody:SetMouseVisible(true);
	winGradMenuBody:SetOpacity(0.8);
	winGradMenuBody:SetVisible(true);
	winGradMenuBody:SetWidth(menuWidth);
	winGradMenuBody:SetZOrder(199);

	winGradMenuHolder = Turbine.UI.Control();
	winGradMenuHolder:SetParent(winGradMenuBody);
	winGradMenuHolder:SetBackColor(MenuBackcolor);
	winGradMenuHolder:SetMouseVisible(true);
	winGradMenuHolder:SetOpacity(0);
	winGradMenuHolder:SetVisible(true);
	winGradMenuHolder:SetWidth(menuWidth);
	winGradMenuHolder:SetZOrder(200);

	gscrollBar = Turbine.UI.ScrollBar();
	gscrollBar:SetParent(winGradMenuBody);
	gscrollBar:SetTop(0);
	gscrollBar:SetZOrder(201);
	gscrollBar:SetMinimum(0);
	gscrollBar:SetWidth(15);
	gscrollBar:SetValue(0);
	gscrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);

	gradScrollIncBut = Turbine.UI.Button();
	gradScrollIncBut:SetSize(15,15);
	gradScrollIncBut:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_inc_up.tga");
	--gradScrollIncBut:SetParent(gscrollBar);

	gradScrollDecBut = Turbine.UI.Button();
	gradScrollDecBut:SetSize(15,15);
	gradScrollDecBut:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_dec_up.tga");
	--gradScrollDecBut:SetParent(gscrollBar);

	scrollThumb = Turbine.UI.Control();
	scrollThumb:SetSize(15,15);
	scrollThumb:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_thumb.tga");
	--scrollThumb:SetParent(gscrollBar);

	gscrollBar:SetDecrementButton(gradScrollDecBut);
	gscrollBar:SetIncrementButton(gradScrollIncBut);
	gscrollBar:SetThumbButton(scrollThumb);

	local curFavColor = BlockSender:GetBackColor();
	curColorString = "R=" .. math.floor(255*curFavColor.R) .. ", G=" .. math.floor(255*curFavColor.G) .. ", B=" .. math.floor(255*curFavColor.B);

	local numOfSlots = 0;

	if blGradReplace[index] == true then -- Replace already active so swap to 'cancel'

		tGradMenu =
		{
			[1] =
			{
				["Name"] = curColorString;
			};
			[2] =
			{
				["Name"] = "Cancel";
			};

		};

		numOfSlots = 2;

	elseif (index == 1) or (index == NUMGRADIENTS) then

		tGradMenu =
		{
			[1] =
			{
				["Name"] = curColorString;
			};
			[2] =
			{
				["Name"] = "Replace";
			};

		};

		numOfSlots = 2;

	else

		tGradMenu =
		{
			[1] =
			{
				["Name"] = curColorString;
			};
			[2] =
			{
				["Name"] = "Replace";
			};
			[3] =
			{
				["Name"] = "Remove";
			};

		};

		numOfSlots = 3;

	end


	winGradMenuItem = {};
	winGradMenuLabel = {};

	--------------------------------------------------------------------------
	-- This loop determines which gambits to add to the menu, and creates
	-- the menu on the fly.

	while i <= numOfSlots do -- loops through all the gambits in the table.

		local gName = tGradMenu[i].Name;

		winGradMenuItem[mCounter] = Turbine.UI.Control();
		winGradMenuItem[mCounter]:SetHeight(lineHeight);
		winGradMenuItem[mCounter]:SetLeft(linebuffer);
		winGradMenuItem[mCounter]:SetTop(menuCurTop);
		winGradMenuItem[mCounter]:SetWidth(menuWidth - (2 * linebuffer));
		winGradMenuItem[mCounter]:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0));
		winGradMenuItem[mCounter]:SetOpacity(1);
		winGradMenuItem[mCounter]:SetMouseVisible(true);
		winGradMenuItem[mCounter]:SetParent(winGradMenuHolder);


		winGradMenuLabel[mCounter] = Turbine.UI.Label();
		winGradMenuLabel[mCounter]:SetParent(winGradMenuItem[mCounter]);
		winGradMenuLabel[mCounter]:SetHeight(lineHeight-4);
		winGradMenuLabel[mCounter]:SetLeft(0);
		winGradMenuLabel[mCounter]:SetTop(2);
		winGradMenuLabel[mCounter]:SetWidth(winGradMenuItem[mCounter]:GetWidth());
		winGradMenuLabel[mCounter]:SetText(gName);
		winGradMenuLabel[mCounter]:SetForeColor(Turbine.UI.Color(1,1,1));
		winGradMenuLabel[mCounter]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		winGradMenuLabel[mCounter]:SetMultiline(false);
		winGradMenuLabel[mCounter]:SetMouseVisible(false);


		------------------------------------------------------------------------------
		-- Mouse event handlers
		winGradMenuItem[mCounter].MouseEnter = function(sender, args)

			local Children = sender:GetControls();
			local cCount = Children:GetCount();
			local label = Children:Get(cCount);
			local selItem = label:GetText();

			if selItem ~= curColorString then

				sender:SetBackColor(Turbine.UI.Color(0.0, 0.3, 0.3));

			end

		end


		winGradMenuItem[mCounter].MouseLeave = function(sender, args)
			sender:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0));
		end


		winGradMenuItem[mCounter].MouseClick = function(sender, args)

			-- This block of code will determine which winGradMenuItem was
			-- clicked and return it's child controls so we can see
			-- which label child corresponds to it.
			local Children = sender:GetControls();
			local cCount = Children:GetCount();
			local label = Children:Get(cCount);
			local selItem = label:GetText();

			--loop through tables to find selected item
			local y = 1;

			while y <= numOfSlots do
				local selName = tGradMenu[y].Name;
				if selName == selItem then


					-- DO SOMETHING HERE

					if selItem == "Replace" then

						enableGradReplace(BlockSender,index);

					elseif selItem == "Cancel" then

						disableGradReplace(index);

					elseif selItem == "Remove" then

						gradRemove(index);

					end



					break
				else
					y = y + 1;
				end

			end

			winGradMenuParent:SetVisible(false); -- Hide menu after click.

		end


		-- Click outside menu, close window.
		winGradMenuParent.MouseClick = function(sender, args)
			winGradMenuParent:SetVisible(false);
		end


		------------------------------------------------------------------------------
		-- Increments

		menuCurTop = menuCurTop + lineHeight + linebuffer;

		mCounter = mCounter + 1;
		menuCurHeight = menuCurTop;


		if menuCurHeight > menuMaxHeight then
			-- Do not make menu larger, instead add a scrollbar.
			winGradMenuBody:SetHeight(menuMaxHeight);
			winGradMenuBody:SetWidth(menuWidth + 16);
			winGradMenuHolder:SetHeight(menuCurHeight);

			gscrollBar:SetLeft(menuWidth);
			gscrollBar:SetMaximum(menuCurHeight - menuMaxHeight);
			gscrollBar:SetHeight(menuMaxHeight);

			gradScrollIncBut:SetTop(gscrollBar:GetHeight()-15);
			gradScrollDecBut:SetTop(0);
			scrollThumb:SetTop(15);
			gscrollBar:SetVisible(true);

			local visiblePercent = menuMaxHeight / menuCurHeight;
			local thumbSize = (menuMaxHeight * visiblePercent) - 30;

			scrollThumb:SetHeight(thumbSize);
			scrollThumb:SetStretchMode(3);

			gscrollBar:SetSmallChange(10);
			gscrollBar:SetLargeChange(20);

			gscrollBar.ValueChanged = function(sender, args)
				-- Move the Holder Window up/down depending on bar value.
				local thumbValue = gscrollBar:GetValue();
				local holderTop = -(thumbValue);

				winGradMenuHolder:SetTop(holderTop);
			end

		else
			winGradMenuBody:SetHeight(menuCurHeight);
			winGradMenuBody:SetWidth(menuWidth);
			winGradMenuHolder:SetHeight(menuCurHeight);
			gscrollBar:SetVisible(false);
		end

		-- increment i for loop.
		i = i + 1;

	end

end
